var buzzBookingDate = '';
jQuery(function($) {
	initBookingsVouchers();
	initBookingsDates();
	initBookingsMultiExperience();
	initBookingsPrivateHire();
	initBookingsExtras();
});

function initBookingsVouchers() {
	var $packages = $('.js-buzz-bookings-packages');
	if ($('.js-bookings-selected-voucher').length) {
		$('.js-bookings-select-voucher-label').removeClass('hidden');
	}

	// Take over handling of the hidden packages from the CSS.
	if ($packages.hasClass('hidden')) {
		$packages.hide().removeClass('hidden');
	}

	if (hasValidVouchers()) {
		$('.js-has-valid-vouchers').css('display', 'none').removeClass('hidden').fadeIn();
	}

	$('body').on('change', '.js-bookings-toggle--vouchers', function(){
		var $toggleContent = $(this).parent().parent().parent().next('.toggle__content');
		var $_this = $(this);
		if ($('input', this).is(':checked')) {
			$toggleContent.slideDown(600);
			$_this.fadeOut(600);
			if (!hasSelectedPackages()) {
				// Hide the packages.
				$packages.slideUp();
				if (hasSelectedPackages() === false && hasValidVouchers() === false) {
					$('.js-button-proceed').prop('disabled', true);
				}
				$('.js-extra-places').css('display', 'none').removeClass('hidden').fadeIn();
			}
			// Reveal the message about adding packages to a voucher booking. We're delaying
			// this to allow time for the packages to get hidden.
			$('.js-has-valid-vouchers').css('display', 'none').removeClass('hidden').delay(800).fadeIn();
		}
	});
	$('.js-bookings-toggle--vouchers').trigger('change');

	var $checkVoucherBtn = $('.js-bookings-check-voucher');
	$checkVoucherBtn.attr('disabled', true);
	$('body').on('change', '.js-bookings-voucher-provider select', function() {
		var $voucherSelect = $('.js-bookings-select-voucher');
		var $pinCode = $('.js-bookings-voucher-pin-code');
		var $expiryDate = $('.js-bookings-voucher-expiry-date');

		$voucherSelect.addClass('hidden');
		$pinCode.addClass('hidden');
		$('.select', $voucherSelect).empty();

		if (vouchers.hasOwnProperty($(this).val())) {
			var $voucherProvider = $(this);
			var $select = $('<select />')
				.attr('name', 'data[BookingItemVoucher][api_voucher_id]')
				.on('change', function() {
					if (vouchers[$voucherProvider.val()][$(this).val()]['requires_pin_code']) {
						$pinCode.removeClass('hidden');
					} else {
						$pinCode.addClass('hidden');
					}
					if (vouchers[$voucherProvider.val()][$(this).val()]['requires_expiry_date']) {
						$expiryDate.removeClass('hidden');
					} else {
						$expiryDate.addClass('hidden');
						$expiryDate.find('input').val('');
					}
				});

			$pinCode.addClass('hidden');
			$('<option />').text(__('Please select')).val(0).appendTo($select);
			$.each(vouchers[$voucherProvider.val()], function(key, val){
				$select.append($('<option />').val(key).text(val.name));
			});
			$voucherSelect.removeClass('hidden');
			$('.select', $voucherSelect).append($select);
			customFormElements();
		} else if ($('.js-bookings-voucher-provider select').val()) {
			$expiryDate.removeClass('hidden');
		}
		if (! $('.js-bookings-select-voucher select, .js-bookings-selected-voucher').length) {
			$('.js-bookings-select-voucher-label').addClass('hidden');
		} else {
			$('.js-bookings-select-voucher-label').removeClass('hidden');
		}

	});
	$('.js-bookings-voucher-provider select').trigger('change');
	$('body').on('change', '.js-bookings-add-voucher-form', function(){
		if (
			$('input, select', this).filter(function(){
				return !$(this).closest('.hidden').length && (!$(this).val() || $(this).val() == 0);
			}).length === 0
		) {
			$checkVoucherBtn.attr('disabled', false);
		} else {
			$checkVoucherBtn.attr('disabled', true);
		}
	});
	// Validate a voucher - adds the voucher on success
	$('body').on('click', '.js-bookings-check-voucher', function(e){
		e.preventDefault();
		var $form = $(this).closest('form');
		$.ajax({
			'cache': false,
			'url': $form.attr('action'),
			'data': $form.serialize()
		}).done(function(data){
			$('.js-bookings-add-voucher-form').replaceWith(data);
			customFormElements();
			$checkVoucherBtn.attr('disabled', true);
			$('.js-bookings-voucher-provider select').trigger('change');
			if (hasSelectedPackages() === true || hasValidVouchers() === true) {
				$('.js-button-proceed').prop('disabled', false);
			}
		});
	});
	$('body').on('click', '.js-bookings-add-voucher', function(e){
		e.preventDefault();
		var $row = $(this).closest('.row');
		$.ajax({
			'context': this,
			'cache': false,
			'url': $(this).data('url')
		}).done(function(data){
			$row.replaceWith(data);
			customFormElements();
			$checkVoucherBtn.attr('disabled', true);
			$('.js-bookings-voucher-provider select').trigger('change');
		});
	});
	$('body').on('click', '.js-bookings-remove-voucher', function(e){
		e.preventDefault();
		var $voucher = $(this).closest('.js-voucher');
		$voucher.remove();
		$.ajax({
			'context': this,
			'cache': false,
			'url': $(this).attr('href')
		}).done(function(data){
			$voucher.remove();
		});
	});
	$('body').on('click', '.js-extra-places', function(e){
		e.preventDefault();
		$packages.slideDown();
		$(this).fadeOut();
	});

	$('body').on('change', '.js-quantity', function(){
		if (hasSelectedPackages() === true || hasValidVouchers() === true) {
			$('.js-button-proceed').prop('disabled', false);
		} else {
			$('.js-button-proceed').prop('disabled', true);
		}
	});
	$('.js-quantity').trigger('change');

	function hasValidVouchers() {
		return !!$('.basket__delete').length;
	}

	function hasSelectedPackages() {
		return !!$('.js-listing-highlight--highlighted').length;
	}
}

function initBookingsDates() {

	var $form = $('.js-bookings-availability');

	if (!$form.length) {
		return;
	}

	if ($form.hasClass('ajax-loader')) {
		$form.toggleClass('ajax-loader ajax-loading');
	}

	$.ajax({
		'cache': false,
		'url': $form.data('src')
	}).done(function(data){
		$form.removeClass('ajax-loading');
		$form.append(data);
		customFormElements();
		BookingsSelectDate();
	});

	BookingsSelectTime();

}

function BookingsSelectDate() {
	var $date = $('.js-booking-date');

	var $form = $('#BookingDateForm');

	$form.on('change', '.radio--times', function(){
		$('button', $form).removeAttr('disabled');
	});

	var pageLoad = true;

	$(document).on('change', $date, function(){
		if (buzzBookingDate !== $date.val()) {
			buzzBookingDate = $date.val();
			$.ajax({
				'cache': false,
				'url': $date.data('src') + '/' + $date.val()
			}).done(function(data){
				$('.js-booking-times').html(data);
				// Radio for time slots in booking process
				if ($(".radio--times").length) {
					if (!$.fn.customRadio) {
						console.log("Main: jquery.customRadio.js must be loaded!");
						return;
					}
					$(".radio--times").customRadio();
				}
				if (pageLoad === false) {
					$('html, body').animate({
						scrollTop: $('#available-times').offset().top
					}, 2000);
				}

				pageLoad = false;
			});
			$('button', $form).attr('disabled', 'disabled');
		}
	});
	$date.trigger('change');
}

function BookingsSelectTime() {
	$(document).on('click', '.radio--booking__time', function() {
		var $arrivalTimeNotice = $('.js-bookings-checkin');
		var text = $arrivalTimeNotice.data('text').replace(/%s/, $(this).data('checkin'));
		$arrivalTimeNotice.html('<p><strong>' + __('Remember') + ':</strong> ' + text + '</p>');

		$activityTimes = $('.js-activity-times--' + $(this).val());
		$('.js-activity-times ul').addClass('hidden');
		if ($activityTimes.length) {
			$activityTimes.closest('.js-activity-times').removeClass('hidden');
			$activityTimes.removeClass('hidden');
		} else {
			$activityTimes.closest('.js-activity-times').addClass('hidden');
		}
		$('#BookingDateForm button').removeAttr('disabled');
	});
}

function initBookingsMultiExperience() {
	$form = $('#BookingPackagesForm');
	if ($form.hasClass('js-multi-experience') === false) {
		return;
	}
	$form.on('change', 'select', function(){
		var count = 0;
		$form = $('#BookingPackagesForm');
		$('select', $form).each(function(){
			count += parseInt($(this).val());
		});
		if (count === 0) {
			$('.listing--activity').removeClass('listing--disabled');
			$('select', $form).removeAttr('disabled');
			$('.js-bookings-voucher-booking').fadeIn(600);
		} else {
			$('.listing--activity').addClass('listing--disabled');
			$(this).closest('.listing--activity').removeClass('listing--disabled');
			$('select', $form).attr('disabled', true);
			$(this).removeAttr('disabled');
			$('.js-bookings-voucher-booking').fadeOut(600);
		}
	});
	$('select', $form).each(function(){
		if ($(this).val() > 0) {
			$(this).trigger('change');
		}
	});

	$('body').on('change', '.js-bookings-toggle--vouchers', function(){
		if ($('input', this).is(':checked')) {
			$('#BookingPackagesForm').fadeOut(600);
		}
	});
}

function initBookingsPrivateHire() {
	var $packages = $('.js-bookings-private-hire');
	if (!$packages.length) {
		return;
	}

	$('body').on('change', '.js-bookings-toggle--vouchers', function(){
		if ($('input', this).is(':checked')) {
			$packages.fadeOut(600);
		}
	});
}

function initBookingsExtras() {
	$form = $('#BookingExtrasForm');
	if (!$form.length) {
		return;
	}
	$('.js-listing-bookable-upsell', $form).on('change', 'select', function(){
		var count = 0;
		$('select', $form).each(function(){
			count += parseInt($(this).val());
		});
		if (count === 0) {
			$('.js-listing-bookable-upsell').removeClass('listing--disabled');
			$('.js-listing-bookable-upsell select', $form).removeAttr('disabled');
		} else {
			$('.js-listing-bookable-upsell').addClass('listing--disabled');
			$(this).closest('.listing--activity').removeClass('listing--disabled');
			$('.js-listing-bookable-upsell select', $form).attr('disabled', true);
			$(this).removeAttr('disabled');
		}
	});
	$('.js-listing-bookable-upsell select', $form).each(function(){
		if ($(this).val() > 0) {
			$(this).trigger('change');
		}
	});
}
